%define url_ver %(echo %{version}|cut -d. -f1,2)

%define enable_gtkdoc 0
%define enable_bootstrap 0
%define enable_tests 0

%define pkgname		gtk+
%define api		3
%define api_version	3.0
%define binary_version	3.0.0
%define major		0
%define libname		%mklibname %{pkgname} %{api} %{major}
%define devname		%mklibname -d %{pkgname} %{api_version}
# this isnt really a true lib pkg, but a modules/plugin pkg
%define modules		%mklibname gtk-modules %{api_version}

%define gail_major	0
%define libgail		%mklibname gail %{api} %{gail_major}
%define devgail		%mklibname -d gail %{api_version}

%define libgir		%mklibname gtk-gir %{api_version}

Summary:	The GIMP ToolKit (GTK+), a library for creating GUIs
Name:		%{pkgname}%{api_version}
Version:	3.16.7
Release:	3
License:	LGPLv2+
Group:		System/Libraries
Url:		http://www.gtk.org
Source0:	http://ftp.gnome.org/pub/GNOME/sources/gtk+/%{url_ver}/%{pkgname}-%{version}.tar.xz

BuildRequires:	cups-devel
BuildRequires:	gettext-devel
BuildRequires:	pkgconfig(atk) >= 1.29.2
BuildRequires:	pkgconfig(cairo) >= 1.6.0
BuildRequires:	pkgconfig(colord)
BuildRequires:	pkgconfig(gdk-pixbuf-2.0) >= 2.26
BuildRequires:	pkgconfig(glib-2.0) >= 2.25.10
BuildRequires:	pkgconfig(epoxy)
BuildRequires:	pkgconfig(gobject-introspection-1.0) >= 0.9.5
BuildRequires:	pkgconfig(pango) >= 1.30
BuildRequires:	pkgconfig(pangocairo) >= 1.30
BuildRequires:	pkgconfig(atk-bridge-2.0) >= 2.6.0
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xcomposite)
BuildRequires:	pkgconfig(xcursor)
BuildRequires:	pkgconfig(xdamage)
BuildRequires:	pkgconfig(xext)
BuildRequires:	pkgconfig(xfixes)
BuildRequires:	pkgconfig(xi)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	pkgconfig(xrandr)
BuildRequires:	pkgconfig(xrender)
#gw needed for gtk-update-icon-cache in gtk+3.0 3.0.9
BuildRequires:	gtk+2.0

%if %{enable_tests}
BuildRequires:	x11-server-xvfb
# gw tests will fail without this
BuildRequires	fonts-ttf-dejavu
%endif
%if %{enable_gtkdoc}
BuildRequires:	gtk-doc >= 0.9
BuildRequires:	sgml-tools
BuildRequires:	texlive-texinfo
%endif
%if !%{enable_bootstrap}
Suggests:	xdg-user-dirs-gtk
%endif
Requires:	%{name}-common = %{version}-%{release}
# MD to pull in all the orphaned module loaders
Requires:	fontconfig
Requires:	gdk-pixbuf2.0
Requires:	gio2.0
Requires:	glib2.0-common
Requires:	pango-modules

# standard icons
Requires: adwaita-icon-theme
# required for icon theme apis to work
Requires: hicolor-icon-theme
# split out in a subpackage
Requires: gtk-update-icon-cache

# gtk3 itself includes the Adwaita theme now
Conflicts: adwaita-gtk3-theme < 3.13.3
#Provides: adwaita-gtk3-theme = %{version}-%{release}

# gtk3 no longer provides the GtkThemeEngine interface used there
Obsoletes: gtk3-engines <= 2.91.5

Obsoletes:	gtk-engines3 < 3.0.0
Provides:	%{pkgname}%{api} = %{version}-%{release}

%description
The gtk+ package contains the GIMP ToolKit (GTK+), a library for creating
graphical user interfaces for the X Window System.  GTK+ was originally
written for the GIMP (GNU Image Manipulation Program) image processing
program, but is now used by several other programs as well.  

If you are planning on using the GIMP or another program that uses GTK+,
you'll need to have the gtk+ package installed.

%package common
Summary:	%{summary}
Group:		%{group}
BuildArch:	noarch
Conflicts:	%{name} < 3.3.2-2

%description common
This package contains the common files for the GTK+3.0 graphical user
interface.

%package -n %{modules}
Summary:	%{summary}
Group:		%{group}
Requires:	%{name} = %{version}-%{release}
Provides:	gtk%{api}-modules = %{version}-%{release}
Obsoletes:	%{_lib}gtk+3 < 3.3.4-2
Obsoletes:	%{_lib}gtk+3.0_0 < 3.0.0
Obsoletes:	%{_lib}gtk+-x11-3.0_0 < 3.0.0
Obsoletes:	%{_lib}gtk-engines3 < 3.0.0

%description -n %{modules}
This package contains the immodules, engines and printbackends libraries
for %{name} to function properly.

%package -n %{devname}
Summary:	Development files for GTK+ (GIMP ToolKit) applications
Group:		Development/GNOME and GTK+
Requires:	%{libname} = %{version}-%{release}
Requires:	%{libgir} = %{version}-%{release}
Provides:	%{pkgname}%{api}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n %{devname}
The libgtk+-devel package contains the static libraries and header files
needed for developing GTK+ (GIMP ToolKit) applications. The libgtk+-devel
package contains GDK (the General Drawing Kit, which simplifies the interface
for writing GTK+ widgets and using GTK+ widgets in applications), and GTK+
(the widget set).

%package -n %{libname}
Summary:	Shared libraries of The GIMP ToolKit (GTK+)
Group:		System/Libraries
Requires:	%{name}-common
# These modules are requierd by any program that attempts to print somethin using GTK possibilities
Requires:	%{modules}
Conflicts:	%{_lib}gtk+3_0 < 3.3.2-2

%description -n %{libname}
This package contains the shared libraries needed to run programs dynamically 
linked with gtk+.

%package -n %{libgir}
Summary:	GObject Introspection interface description for %{name}
Group:		System/Libraries
Conflicts:	%{_lib}gtk+3_0 < 3.3.2-2

%description -n %{libgir}
GObject Introspection interface description for %{name}.

%package -n %{libgail}
Summary:	GNOME Accessibility Implementation Library
Group:		System/Libraries
Obsoletes:	%{_lib}gail3.0_0 < 3.0.0

%description -n %{libgail}
Gail is the GNOME Accessibility Implementation Library

%package -n %{devgail}
Summary:	Development libraries, include files for GAIL
Group:		Development/GNOME and GTK+
Provides:	libgail-%{api_version}-devel = %{version}-%{release}
Requires:	%{libgail} = %{version}

%description -n %{devgail}
Gail is the GNOME Accessibility Implementation Library

%package -n gtk-update-icon-cache
Summary: Icon theme caching utility
# gtk-update-icon-cache used to be shipped in the gtk2 package
Conflicts: gtk2 < 2.24.22-6

%description -n gtk-update-icon-cache
GTK+ can use the cache files created by gtk-update-icon-cache to avoid a lot of
system call and disk seek overhead when the application starts. Since the
format of the cache files allows them to be mmap()ed shared between multiple
applications, the overall memory consumption is reduced as well.

%prep
%setup -qn %{pkgname}-%{version}
%apply_patches

%build
# fix crash in nautilus (GNOME bug #596977)
export CFLAGS=`echo %{optflags} | sed -e 's/-fomit-frame-pointer//g'`

%configure2_5x \
	--disable-static \
	--enable-xkb \
	--enable-xinerama \
	--enable-xrandr \
	--enable-xfixes \
	--enable-xcomposite \
	--enable-xdamage \
	--enable-x11-backend \
	--enable-packagekit=yes \
	--enable-gtk2-dependency \
	--enable-colord 

%make

%check
%if %enable_tests
XDISPLAY=$(i=1; while [ -f /tmp/.X$i-lock ]; do i=$(($i+1)); done; echo $i)
%{_bindir}/Xvfb :$XDISPLAY &
export DISPLAY=:$XDISPLAY
make check
kill $(cat /tmp/.X$XDISPLAY-lock) ||:
%endif

%install
%makeinstall_std RUN_QUERY_IMMODULES_TEST=false RUN_QUERY_LOADER_TEST=false

touch %{buildroot}%{_libdir}/gtk-%{api_version}/%{binary_version}/immodules.cache
mkdir -p %{buildroot}%{_libdir}/gtk-%{api_version}/modules

%if "%{_lib}" != "lib"
 mv %{buildroot}%{_bindir}/gtk-query-immodules-%{api_version} %{buildroot}%{_bindir}/gtk-query-immodules-%{api_version}-64
%else
 mv %{buildroot}%{_bindir}/gtk-query-immodules-%{api_version} %{buildroot}%{_bindir}/gtk-query-immodules-%{api_version}-32
%endif

%find_lang gtk30 gtk30-properties gtk30.lang

%post -n %{modules}
if [ "$1" = "2" ]; then
  if [ -f %{_sysconfdir}/gtk-%{api_version}/gtk.immodules ]; then
    rm -f %{_sysconfdir}/gtk-%{api_version}/gtk.immodules
  fi
fi
%if "%{_lib}" != "lib"
 %{_bindir}/gtk-query-immodules-%{api_version}-64 --update-cache
%else
 %{_bindir}/gtk-query-immodules-%{api_version}-32 --update-cache
%endif

%triggerin -n %{modules} -- %{_libdir}/gtk-%{api_version}/%{binary_version}/immodules/*.so
%if "%{_lib}" != "lib"
 %{_bindir}/gtk-query-immodules-%{api_version}-64 --update-cache
%else
 %{_bindir}/gtk-query-immodules-%{api_version}-32 --update-cache
%endif

%triggerpostun -n %{modules} -- %{_libdir}/gtk-%{api_version}/%{binary_version}/immodules/*.so
%if "%{_lib}" != "lib"
 %{_bindir}/gtk-query-immodules-%{api_version}-64 --update-cache
%else
 %{_bindir}/gtk-query-immodules-%{api_version}-32 --update-cache
%endif

%files
%doc README
%{_bindir}/gtk-query-immodules-%{api_version}-*
%{_bindir}/gtk-launch

%files common -f gtk30.lang
%dir %{_sysconfdir}/gtk-%{api_version}
%config(noreplace) %{_sysconfdir}/gtk-%{api_version}/im-multipress.conf
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.FileChooser.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.ColorChooser.gschema.xml
%{_datadir}/themes
%{_mandir}/man1/gtk-query-immodules-%{api_version}.1*
%{_mandir}/man1/gtk-launch.1*
%{_mandir}/man1/broadwayd.1*

%files -n %{modules}
%ghost %verify (not md5 mtime size) %{_libdir}/gtk-%{api_version}/3.0.0/immodules.cache
%dir %{_libdir}/gtk-%{api_version}
%dir %{_libdir}/gtk-%{api_version}/modules
%dir %{_libdir}/gtk-%{api_version}/%{binary_version}
%{_libdir}/gtk-%{api_version}/%{binary_version}/immodules
%{_libdir}/gtk-%{api_version}/%{binary_version}/printbackends

%files -n %{libname}
%{_libdir}/libgtk-3.so.%{major}*
%{_libdir}/libgdk-3.so.%{major}*

%files -n %{libgir}
%{_libdir}/girepository-1.0/Gdk-%{api_version}.typelib
%{_libdir}/girepository-1.0/GdkX11-%{api_version}.typelib
%{_libdir}/girepository-1.0/Gtk-%{api_version}.typelib

%files -n %{devname}
%doc docs/*.txt AUTHORS ChangeLog NEWS* README*
%{_bindir}/gtk3-demo
%{_bindir}/gtk3-demo-application
%{_bindir}/gtk3-widget-factory
%{_bindir}/gtk-encode-symbolic-svg
%{_bindir}/gtk3-icon-browser
%{_includedir}/gtk-%{api_version}
%{_libdir}/libgtk-%{api}.so
%{_libdir}/libgdk-%{api}.so
%{_libdir}/pkgconfig/gdk-*%{api_version}.pc
%{_libdir}/pkgconfig/gtk+-*%{api_version}.pc
%{_datadir}/aclocal/*
%{_datadir}/gtk-%{api_version}
%{_datadir}/gir-1.0/Gdk-%{api_version}.gir
%{_datadir}/gir-1.0/GdkX11-%{api_version}.gir
%{_datadir}/gir-1.0/Gtk-%{api_version}.gir
%{_datadir}/applications/gtk3-demo.desktop
%{_datadir}/applications/gtk3-widget-factory.desktop
%{_datadir}/applications/gtk3-icon-browser.desktop
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.Debug.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.Demo.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.exampleapp.gschema.xml
%{_datadir}/icons/hicolor/*/apps/*.png
%{_mandir}/man1/gtk-encode-symbolic-svg.1*
%{_mandir}/man1/gtk3-demo-application.1*
%{_mandir}/man1/gtk3-demo.1*
%{_mandir}/man1/gtk3-icon-browser.1*
%{_mandir}/man1/gtk3-widget-factory.1*
%doc %{_datadir}/gtk-doc/html/gdk3
%doc %{_datadir}/gtk-doc/html/gtk3

%files -n %{libgail}
%{_libdir}/libgailutil-%{api}.so.%{gail_major}*

%files -n %{devgail}
%{_includedir}/gail-%{api_version}
%{_libdir}/libgailutil-%{api}.so
%{_libdir}/pkgconfig/gail-%{api_version}.pc
%{_datadir}/gtk-doc/html/gail-libgail-util3

%files -n gtk-update-icon-cache
%doc COPYING
%{_bindir}/gtk-update-icon-cache
%{_mandir}/man1/gtk-update-icon-cache.1*

%changelog

* Thu Feb 25 2016 Tigro <ashejn@gmail.com> 3.16.7-3
- (6fb8d25) drop default application patch to fix http://forum.rosalab.ru/viewtopic.php?f=53&t=6859&p=65053#p65053

* Mon Dec 21 2015 Tigro <ashejn@gmail.com> 3.16.7-2
- (d57714e) added C: adwaita-gtk3-theme < 3.13.3
- (Tigro: d2fd7d7) drop P: and O: adwaita-gtk3-theme

* Thu Dec 17 2015 Tigro <ashejn@gmail.com> 3.16.7-1
- (836ea4c) update to 3.16.7
- (Tigro: 884a4ca) update to 3.16.7

* Sat Oct 03 2015 Tigro <ashejn@gmail.com> 3.12.2-9
- (fc8d43b) update patch
- (Tigro: 28945ad) fix GNOME #750994 and #750870

* Wed Jul 08 2015 Tigro <ashejn@yandex-team.ru> 3.16.5-1
- (35d762a) update to 3.16.5

* Tue Jun 16 2015 Denis Silakov <denis.silakov@rosalab.ru> 3.12.2-8
- (05ab0bf) Require "modules" subpackage for the library to avoid problems with printing in GTK-based applications (http://bugs.rosalinux.ru/show_bug.cgi?id=4635)

* Mon Jun 15 2015 Tigro <ashejn@yandex-team.ru> 3.16.4-1
- (ac6a9c0) update to 3.16.4

* Tue May 12 2015 Tigro <ashejn@yandex-team.ru> 3.16.3-1
- (d31aa8e) update to 3.16.3

* Tue Apr 14 2015 Tigro <ashejn@gmail.com> 3.16.2-1
- (2c4b48f) update to 3.16.2

* Wed Apr 08 2015 Tigro <ashejn@yandex-team.ru> 3.16.1-1
- (22d97cd) update patch
- (Tigro: 4a99aa3) update to 3.16.1

* Mon Mar 23 2015 Tigro <ashejn@gmail.com> 3.16.0-1
- (5fd96ff) update to 3.16.0

* Tue Mar 17 2015 Tigro <ashejn@gmail.com> 3.15.12-1
- (dcd9d57) update to 3.15.12

* Tue Mar 17 2015 Tigro <ashejn@yandex-team.ru> 3.15.11-1
- (c9493db) update to 3.15.11

* Wed Mar 11 2015 Tigro <ashejn@yandex-team.ru> 3.15.10-3
- (94084a4) bump release

* Wed Mar 11 2015 Tigro <ashejn@yandex-team.ru> 3.15.10-2
- (2fefcc0) create gtk-update-icon-cache subpackage and Provides adwaita-gtk3-theme
- (Tigro: f5a8cd5) bump release

* Sun Mar 08 2015 Tigro <ashejn@gmail.com> 3.15.10-1
- (b63d530) disable installed tests again
- (Tigro: 7d9f0d7) pack files and enable installed tests
- (Tigro: 82c4f2b) update to 3.15.10

* Sun Mar 08 2015 Tigro <ashejn@gmail.com> 3.15.9-1
- (e6d901f) added BR: epoxy
- (Tigro: 42c1acb) drop old patch
- (Tigro: 64556f1) update default application patch

* Sun Feb 22 2015 Alexander Lakhin <a.lahin@ntcit-rosa.ru> 3.12.2-7
- (7909699) MassBuild#656: Increase release tag

* Sun Nov 16 2014 Tigro <ashejn@gmail.com> 3.12.2-6
- (6310307) added checkbox to allow set default application for any files by default

* Fri Sep 12 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 3.12.2-5
- (36a4b15) Add common subpackage to library Requires

* Mon Sep 08 2014 Tigro <ashejn@gmail.com> 3.12.2-4
- (b2248c7) invert GTK_DISABLE_CSD var
- (Tigro: 0ec2ddf) breaks usability by forcing client side decorations on X11

* Fri Jun 27 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 3.12.2-3
- (540c860) MassBuild#440: Increase release tag

* Mon Jun 16 2014 Tigro <ashejn@gmail.com> 3.12.2-2
- (cba4326) bump release to build against new colord

* Fri May 16 2014 Tigro <ashejn@gmail.com> 3.12.2-1
- (14ac6d9) update to 3.12.2

* Tue Apr 15 2014 Tigro <ashejn@gmail.com> 3.12.1-1
- (0eff0db) update to 3.12.1

* Wed Apr 09 2014 Tigro <ashejn@gmail.com> 3.12.0-1
- (b496c1e) pack some files
- (Tigro: 65b3f49) drop remove
- (Tigro: 48eaad8) disable patch apply
- (Tigro: 4561e42) added source
- (Tigro: 099a7e2) update to 3.12.0

* Thu Oct 17 2013 Tigro <ashejn@gmail.com> 3.8.6-1
- (9ead5e9) drop gtk/gtkdbusgenerated.[hc], these need to be regenerated with the system glib
- (Tigro: c68e001) update to 3.8.6

* Thu Oct 17 2013 Tigro <ashejn@gmail.com> 3.8.5-1
- (d60cc22) added russian translation
- (Tigro: 9a78df0) update to 3.8.5

* Thu Sep 26 2013 Aleksey Yermakov <alexey.yermakov@rosalab.ru> 3.8.4-2
- (8bc9270) Added 'Set as default' checkbox to 'Open with..' dialog.

* Thu Sep 05 2013 Tigro <ashejn@gmail.com> 3.8.4-1
- (23a4862) update to 3.8.4

* Thu Jun 20 2013 root <root@localhost.localdomain> 3.8.2-1
- (d4e7a0d) sync to gnome38 branch

* Wed Nov 21 2012 Andrey Bondrov <andrey.bondrov@rosalab.ru> 3.6.2-1
- (5362aa9) LOG New bugfix version 3.6.2

* Mon Oct 29 2012 mdawkins <mattydaw@gmail.com> 3.6.1-1
- (e216446) new version 3.6.1


